#!/usr/bin/env python
# coding: utf-8

# In[ ]:


# !/usr/bin/env python
# coding: utf-8

Flag_TorchExport =1;
Flag_TorchExport =0;#(Lock moudle)

'''#____________________________________________________________
#{P1-- Library version checking}'''
import platform
import torch
import onnx
import onnxruntime
import openvino.inference_engine
print("Python  version       :",  platform.sys.version)
print("Pytorch version       :",  torch.__version__)
print("CUDA    version       :",  torch.version.cuda)
print("CUDNN   version       :",  torch.backends.cudnn.version())
print("ONNX version          :",  onnx.__version__)
print("ONNXRuntime version   :",  onnxruntime.__version__)
print("OpenVION version      :",  openvino.inference_engine.get_version())


# In[ ]:





# In[ ]:


'''#________________________________________________________________________________________________________
#{Load moudel}'''
import os
import sys
import time
import numpy as np
import torch


# In[ ]:





# In[ ]:


'''#________________________________________________________________________________________________________
#{Define NN structure (Sp offers)}
'''

import torch
import torch.nn as nn
from torch.autograd import Variable
    
class Gate_Conv(nn.Module):
    
    def __init__(self, in_channels =64,                       out_channels=16,                       kernel_size=3,                        stride=2,                        de_flag=1):
        '''
        GNA2.0: filter number < 65532
        formula=filter_size(channelIn*kernel_size) * filter_number(=channel_out) 
        NN2 weights number=(16*3)*16=3072

        '''
        super(Gate_Conv, self).__init__()
        self.de_flag = de_flag
        self.stride  = stride
        self.conv1d_stride = self.stride
        if self.de_flag == 1:
            self.conv1d_stride = 1
        self.conv = nn.Conv1d(in_channels=in_channels * 3, out_channels=out_channels,
                              kernel_size=kernel_size, stride=self.conv1d_stride)
        self.gate_conv = nn.Sequential(
            nn.Conv1d(in_channels=in_channels * 3, out_channels=out_channels,
                      kernel_size=kernel_size, stride=self.conv1d_stride),
            nn.Sigmoid())

    def forward(self, x,):
        x_cat =x
        out = self.conv(x_cat) * self.gate_conv(x_cat)
        return out


# In[ ]:


128*3*3*32


# In[ ]:


'''#________________________________________________________________________________________________________
#{P1: Infer by pytorch}'''

# {Set inference input}______________________________________
device = torch.device("cpu")
device = torch.device("cpu")
NN_Input1_dumy=torch.ones(1, 192, 33).to(device)

# {Define NN}________________________________________________
OptimalNN =Gate_Conv().to(device)
OptimalNN.eval()

#{Save NN as pt }______________________________________________
Path_now = os.getcwd()
delimiter= os.path.sep
Name_OptimalNN_DynamicTimeStep = "NN2_CNN1D"
Path_Pt_stage1        = Path_now + delimiter                         + "Export_Main00"+ delimiter                        + "Tracing_"+Name_OptimalNN_DynamicTimeStep+".pt"
if(1==Flag_TorchExport):
    torch.save({'NN2_CNN1D':OptimalNN.state_dict(),}, Path_Pt_stage1 );
#____________________________________________________________
#{P4-- Infer with input (Pytorch template)}

# {Infer by pytorch}
out_dec= OptimalNN(NN_Input1_dumy)

Out =out_dec
print("#_________________________________")
print("Pytorch infers ")
print("NN_Input1_dumy.size():", NN_Input1_dumy.size())
print("Out.size():", Out.size())
print("Out[0,0,0]:", Out[0,0,0].item())


# In[ ]:


'''#________________________________________________________________________________________________________
#{P2: Trace and export as ONNX}'''
import netron
import onnxruntime as ort
import onnxruntime.backend as backend
import onnx

# {Set inference input}_________________________________________________
device = torch.device("cpu")
NN_Input1_dumy=torch.ones(1, 192, 33).to(device)

# {Define NN}___________________________________________________________
OptimalNN =Gate_Conv().to(device)


# {Load parameters}_____________________________________________________
model_dict = torch.load(Path_Pt_stage1 , map_location= device)
OptimalNN.load_state_dict(model_dict['NN2_CNN1D'])# Define NN with fixed parameters
OptimalNN.eval();

#{Save as ONNXs}_______________________________________________________
Path_now = os.getcwd()
delimiter= os.path.sep
Name_OptimalNN_DynamicTimeStep = "NN2_CNN1D"
Path_ONNX_stage1        = Path_now + delimiter                         + "Export_Main00"+ delimiter                        + "Tracing_"+Name_OptimalNN_DynamicTimeStep+".onnx"
OptimalNN.eval()
torch.onnx.export(OptimalNN, args=(NN_Input1_dumy),                                   f=Path_ONNX_stage1,                                   input_names=['in'],                                   output_names=['out'],                                   verbose=False,                                   opset_version=11)


# In[ ]:





# In[ ]:


'''#__________________________________________________________________________
#{P3:Inference TEST}'''
#___________________________________________________________________
# {Infer by pytorch pt}_____________________________________________

# {initial inference input}
device = torch.device("cpu")
NN_Input1_dumy=torch.ones(1, 192, 33).to(device)


# {Define & loadNN}_________________________________________
OptimalNN =Gate_Conv().to(device)
model_dict = torch.load(Path_Pt_stage1 , map_location= device)
OptimalNN.load_state_dict(model_dict['NN2_CNN1D'])# Define NN with fixed parameters
OptimalNN.eval();


#____________________________________________________________
#{P4-- Infer with input (Pytorch template)}

# {Infer by pytorch}
out_dec= OptimalNN( NN_Input1_dumy)

Out =out_dec
print("#_________________________________")
print("Pytorch infers ")
print("Out.size():", Out.shape)
print("Out[0,0,0]:", Out[0,0,0].item())


#___________________________________________________________________
# {Infer by ONNX}___________________________________________________
import onnxruntime 
import onnxruntime.backend as backend
import onnx

# {initial inference input}
NN_Input1_dumy= torch.ones(1, 192, 33)
onnx_in_list  = [NN_Input1_dumy.numpy()]

##{Get IO's key name}
Path_now = os.getcwd()
delimiter= os.path.sep
Name_OptimalNN_DynamicTimeStep = "NN2_CNN1D"
Path_ONNX_stage1        = Path_now + delimiter                         + "Export_Main00"+ delimiter                        + "Tracing_"+Name_OptimalNN_DynamicTimeStep+".onnx"
session = onnxruntime.InferenceSession(Path_ONNX_stage1)
session.get_modelmeta()
inname    = [input.name  for input in session.get_inputs()]
outname   = [output.name for output in session.get_outputs()]
inshape   = [input.shape  for input in session.get_inputs()]
outshape  = [output.shape for output in session.get_outputs()]

##{Set ONNX input dictionary}
onnx_in_dict={key:0 for key in inname }
for i in range(len(inname)):
    onnx_in_dict[inname[i]]=onnx_in_list[i]


##{ONNX infers}
ONNX_Pred_stage1 = session.run(outname, onnx_in_dict)

##{Set up ONNX output}
Out               = ONNX_Pred_stage1[0]

print("#_________________________________")
print("ONNX infers ")
print("Out.size():", Out.shape)
print("Out[0,0,0]:", Out[0,0,0].item())
# for i in range(len(outname)):
#     print('outname{}:{}'.format(i,outname[i]))

#___________________________________________________________________
# {Infer by OpenVINO}_______________________________________________
from openvino.inference_engine import IECore, Blob, TensorDesc

Mode = 1;#CPU infers
Mode = 2;#GNA infers

# {initial inference input}
IR_Folder   =Path_now + delimiter + "Export_Main00"+ delimiter +"IR_FP32_OpenVINO2022p1"+ delimiter 
Path_IR_Xml =IR_Folder+ "Tracing_"+ Name_OptimalNN_DynamicTimeStep+".xml"
Path_IR_Bin =IR_Folder+ "Tracing_"+ Name_OptimalNN_DynamicTimeStep+".bin"

##{Read IR}------------------------------------------------
ie  = IECore()
net = ie.read_network(model=Path_IR_Xml, weights=Path_IR_Bin)

##{check input and output names & shapes}-------------------
input_shapes_dict  = {k: v.input_data.shape for k, v in net.input_info.items()}
input_names   = list(net.input_info.keys())
output_names  = list(net.outputs.keys())

##{load model to the device --CPU or GNA or GPU}------------
if(1==Mode):
    exec_net = ie.load_network(network=net, device_name="CPU", num_requests=8)
    infer_request_ptr   = exec_net.requests[0] #Note:  get the network's pointer
    
elif(2==Mode):
    Config_Stage1_GNA_FP32    = {'GNA_DEVICE_MODE': 'GNA_HW', 'GNA_SCALE_FACTOR_0:0' : '1.0',}
    exec_net = ie.load_network(network=net, device_name='GNA', config=Config_Stage1_GNA_FP32)
    infer_request_ptr   = exec_net.requests[0] #Note:  get the network's pointer
    
   
    
##{Forms input (Tensor specification)}-------------------------
NN_Input1_dumy= torch.ones(1, 192, 33).to(device)
onnx_in_list  = [NN_Input1_dumy.numpy()]
Encoder_TD_LIST   = [] 
Encoder_blob_LIST = [] 
for i in range(len(inname)):
    Dim =len(tuple(input_shapes_dict[inname[i]])) #get the dimension of tensor:(a,b,c)==dim3
    TD  =TensorDesc("FP32", tuple(input_shapes_dict[inname[i]]), layout='CHW')
    IR_Blob = Blob(TD, onnx_in_list[i])
    Encoder_TD_LIST.append(TD)
    Encoder_blob_LIST.append(IR_Blob) 
    infer_request_ptr.set_blob(inname[i], IR_Blob )
    
##{IR infers}
infer_request_ptr.infer()

##{Set up IR output}
Out=infer_request_ptr.output_blobs["out"] .buffer


print("#_________________________________")
print("Openvino infers ")
print("Out.size():", Out.shape)
print("Out[0,0,0]:", Out[0,0,0].item())


# In[ ]:




